# Benchmarks

This report describes the performance of a set of constraints expressed
using the constructs in the `ValueConstraints` package versus the 'vanilla'
implementation, i.e. using basic Julia functions, using
[`BenchmarkTools`](https://juliaci.github.io/BenchmarkTools.jl/).

| Benchmark                                    | Time                | Memory              |
| -------------------------------------------- | ------------------- | ------------------- |
| Constraint Inversion                         | Invariant (97.25%)  | Invariant (100.00%) |
| Exhaustive Compound Multiple Type Constraint | Invariant (95.30%)  | Invariant (100.00%) |
| Exhaustive Less or Greater Than              | Invariant (103.08%) | Invariant (100.00%) |
| Exhaustive Slow Comparison or Less Than      | Invariant (97.23%)  | Invariant (100.00%) |
| Less Than                                    | Invariant (101.00%) | Invariant (100.00%) |

---

This report was generated by executing the following command from the root
of the project:

```sh
$ julia --eval='include("./benchmarks/benchmarks.jl")' \
        --eval='Benchmarks.report()' \
        --project=benchmarks
```
